routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => 'auth'], function() {
    Route::get('/', 'HomeController@index')->name('home');

    Route::get('posts/check/{restaurant_id}', 'PostController@check')->name('restaurants.check');
    Route::get('posts/uncheck/{restaurant_id}', 'PostController@uncheck')->name('restaurants.uncheck');
    Route::resource('posts', 'PostController');
// Route::view('posts', 'posts.index', ['url' => 'https://api.gnavi.co.jp/RestSearchAPI/v3/', 'keyid' => 'efa8a992882d97178436f93f2637677f']);
});

Auth::routes();

app/Models/Comment.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Comment extends Model
{
    public function post()
    {
        return $this->belongsTo('App\Models\Post');
    }

    public function user()
    {
        return $this->belongsTo('App\Models\User');
    }

    public function comment(string $id)
    {
        return Comment::where('restaurant_id', $id)->first();
    }
}

app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Carbon\Carbon;

class Post extends Model
{
    protected $table = 'posts';

    // statusにラベルをつける
    const STATUS = [
        0 => ['label' => '行きたい'],
        1 => ['label' => '行った'],
    ];
    public function getStatusLabelAttribute()
    {
        $status = $this->attributes['status'];

        if(!isset(self::STATUS[$status])){
            return '';
        }
        return self::STATUS[$status]['label'];
    }

    // 日付の形式も変える
    public function getFormattedDateAttribute()
    {
        return Carbon::createFromFormat('Y-m-d', $this->attributes['date'])->format('Y/m/d');
    }

    public function comments()
    {
        return $this->hasMany('App\Models\Comment');
    }

    public function user()
    {
        return $this->belongsTo('App\Models\User');
    }

    public function getAllPosts()
    {
        return Post::all();
    }

    public function getUserPosts(int $user_id)
    {
        $posts = Post::where('user_id', $user_id)->get();
        return $posts;
    }

    public function createPostCheck(string $restaurant_id, $date, $comment_text)
    {
        $post = new Post();
        $comment = new Comment();
        // dd($comment);

        // ポストテーブルの保存
        $post->restaurant_id = $restaurant_id;
        $post->user_id = Auth::user()->id;
        if ($date == null) {
            $post->date = Carbon::now()->format('Y/m/d');
        } else {
            $post->date = $date;
        }
        $post->status = true;
        Auth::user()->posts()->save($post);

        // コメントテーブルの保存
        $comment->restaurant_id = $post->restaurant_id;
        $comment->user_id = $post->user_id;
        $comment->content = $comment_text;
        Auth::user()->comments()->save($comment);

        return $post;
    }

    public function createPostUncheck(string $restaurant_id)
    {
        $post = new Post();

        $post->restaurant_id = $restaurant_id;
        $post->user_id = Auth::user()->id;
        $post->date = Carbon::now()->format('Y/m/d');

        $post->status = false;
        Auth::user()->posts()->save($post);

        return $post;
    }

    public function editPost(Post $post, Request $request)
    {
        $post->date = $request->date;
        $post->status = $request->status;
        $post->save();
    }

    public function getPost($id)
    {
        return Post::where('restaurant_id', $id)->first();
    }
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function posts()
    {
        return $this->hasMany('App\Models\Post');
    }

    public function comments()
    {
        return $this->hasMany('App\Models\Comment');
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        $user = Auth::user();

        // ログインユーザーに紐づく投稿を取得
        $post = $user->posts()->first();

        if(is_null($post)){
            return view('home');
        }

        return redirect()->route('posts.index');
    }
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Services\PostService;
use App\Services\CommentService;
use Illuminate\Support\Facades\Auth;
// use Illuminate\Support\Facades\DB;
use App\Http\Requests\CreatePost;
use App\Http\Requests\EditPost;
use Prophecy\Call\Call;

class PostController extends Controller
{
    protected $postService;

    public function __construct(PostService $postService, CommentService $commentService)
    {
        $this->postService = $postService;
        $this->commentService = $commentService;
    }

    public function index()
    {
        // ユーザーの持つポスト取得
        $post_ids = Auth::user()->posts()->pluck('restaurant_id');
        foreach($post_ids as $post_id)
        {
            $data[] = $this->postService->getAPIData(['id' => $post_id]);
            $post[] = Auth::user()->posts->where('restaurant_id', $post_id)->first();
        }
        return view('posts.index', [
            'post' => $post,
            'data' => $data,
        ]);
    }

    public function show(string $restaurant_id)
    {
        $post = $this->postService->getPost($restaurant_id);
        $datum = $this->postService->getAPIData(['id' => $restaurant_id]);
        $comment = $this->commentService->getComment($restaurant_id);

        return view('posts.show', [
            'post'    => $post,
            'datum'   => $datum,
            'comment' => $comment
        ]);
    }

    public function create()
    {
        $res = $this->postService->getAPIData();

        return view('posts/create', [
            'restaurants' => $res['rest'],
        ]);
    }

    public function check(string $restaurant_id, Request $request)
    {
        $date = $request->date;
        $comment_text = $request->comment;
        $post = $this->postService->createPostCheck($restaurant_id, $date, $comment_text);

        return redirect()->route('posts.index');
    }

    public function uncheck(string $restaurant_id)
    {
        $post = $this->postService->createPostUncheck($restaurant_id);

        return redirect()->route('posts.index');
    }

    public function edit(string $restaurant_id)
    {
        $post = $this->postService->getPost($restaurant_id);
        $datum = $this->postService->getAPIData(['id' => $restaurant_id]);

        return view('posts/edit', [
            'post' => $post,
            'datum' => $datum,
        ]);
    }

    public function update(Request $request, string $restaurant_id)
    {
        $post = $this->postService->getPost($restaurant_id);
        $this->postService->editPost($post, $request);

        return redirect()->route('posts.index');
    }

    public function destroy(string $restaurant_id)
    {
        $post = $this->postService->getPost($restaurant_id);

        $post->delete();

        return redirect()->to('posts');
    }
}

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
<div class="container">
    <div class="row justify-content-center">
        <div class="col-md-8">
            <div class="card">
                <div class="card-header">Dashboard</div>

                <div class="card-body">
                    @if (session('status'))
                        <div class="alert alert-success" role="alert">
                            {{ session('status') }}
                        </div>
                    @endif
                    <a href="{{ route('posts.create') }}">投稿する</a>
                    You are logged in!
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>
    @yield('styles')
    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.3/jquery.min.js"></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">

</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    Gohanbox
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li class="nav-item">
                                <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                            </li>
                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                        onclick="event.preventDefault();
                                        document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
    @yield('scripts')
</body>
</html>

resources/views/posts/create.blade.php
@extends('layouts.app')

@section('styles')
    @include('share.flatpickr.styles')
    <style>
    /* #date {
        width: 90px;
    } */
    li {
        list-style: none;
    }
    </style>
@endsection


@section('content')
<div class="container">
    <h1>渋谷のお店一覧</h1>

    @if($errors->any())
    <div class="alert alert-danger">
        <ul>
            @foreach($errors->all() as $message)
            <li>{{ $message }}</li>
            @endforeach
        </ul>
    </div>
    @endif

    <div class="row">
    <div class="col-md-12">
        <table class="table table-bordered">
            <thead>
                <tr>
                    <th scope="col" class="text-center">名前</th>
                    <th scope="col" class="text-center">エリア</th>
                    <th scope="col" class="text-center">お店の登録</th>
                </tr>
            </thead>
            <tbody>
                @foreach($restaurants as $restaurant)
                <tr>
                    <td>
                        <ul class="d-flex align-items-center">
                            <li><img src="{{ $restaurant['image_url']['shop_image1'] }}" width="120" height="120"></li>
                            <li class="ml-3">{{ $restaurant['name'] }}</li>
                        </ul>
                    </td>
                    <td>{{ $restaurant['code']['areaname_s'] }}</td>
                    <td>
                        @if(Auth::user()->posts->where('restaurant_id', $restaurant['id'])->first())
                        <button type="button" class="btn btn-secondary" disabled>登録済み</button>
                        @else
                        <form action="{{ route('restaurants.check', [ 'restaurant_id' => $restaurant['id'] ]) }}" method="GET">
                            {{ csrf_field() }}
                            <input type="text" class="form-control mb-1" placeholder="コメントを入力" name="comment">
                            <div class="d-flex align-items-center mb-3">
                                <input type="text" id="date" class="form-control" placeholder="日付" name="date">
                                <input type="submit" value="行ったお店として登録" class="btn btn-primary mx-2">
                            </div>
                        </form>
                        <form action="{{ route('restaurants.uncheck', [ 'restaurant_id' => $restaurant['id'] ]) }}" method="GET">
                            {{ csrf_field() }}
                            <input type="submit" value="行きたいお店として登録" class="btn btn-warning w-100">
                        </form>
                        @endif
                    </td>
                </tr>
                @endforeach
            </tbody>
        </table>
        <a href="{{ route('posts.index') }}"><button type="button" class="btn btn-secondary">Back</button></a>


    </div>
    </div>
</div>
@endsection

@section('scripts')

<!-- 日本語化のための追加スクリプト -->
{{-- <script src="https://cdn.jsdelivr.net/npm/flatpickr/dist/l10n/ja.js"></script> --}}
<script>
    const flatpickr = require('flatpickr');
    flatpickr('#date', {
        locale: 'ja',
        dateFormat: 'Y/m/d',
        minDate: 2019/1/1,
        allowInput: true
    });
</script>
    {{-- @include('share.flatpickr.scripts') --}}
{{--
    <script>
    $(function() {
        // controllerから現在のページを取得
        let page = {{ $page }};

        $.getJSON('/')

    })

    </script> --}}
@endsection

resources/views/posts/edit.blade.php
@extends('layouts.app')

@section('styles')
    @include('share.flatpickr.styles')
    <style>
    li {
        list-style: none;
    }
    </style>
@endsection


@section('content')
<div class="container">
    <h1>Edit</h1>

    @if($errors->any())
    <div class="alert alert-danger">
        <ul>
            @foreach($errors->all() as $message)
            <li>{{ $message }}</li>
            @endforeach
        </ul>
    </div>
    @endif

    <div class="row">
    <div class="col-md-6 offset-md-3">

    <form action="{{ route('posts.update', ['id' => $post->restaurant_id]) }}" method="post">
    @csrf
    {{ method_field('patch') }}
        <div class="form-group">{{ $datum['rest'][0]['name'] }}</div>
        <div class="form-group d-flex">
            <label><input type="radio" id="js-check" class="form-control" name="status" value="1" {{ old('status', $post->status) === 1 ? 'checked': '' }} onClick="buttonCheck();">行った</label>
            <label><input type="radio" id="js-uncheck" class="form-control" name="status" value="0" {{ old('status', $post->status) === 0 ? 'checked': '' }} onClick="buttonUnCheck();">行きたい</label>
        </div>
        @if($post->status === 1)
        <div class="form-group" id="js-dateForm">
            <label for="date">日付</label>
            <input type="text" class="form-control" name="date" id="date" value="{{ old('date', $post->formatted_date) }}">
        </div>
        @else
        <div class="form-group" id="js-dateForm" style="display:none;">
            <label for="date">日付</label>
            <input type="text" class="form-control" name="date" id="date" value="{{ old('date', $post->formatted_date) }}">
        </div>
        @endif

        <a href="{{ route('posts.show', ['restaurant_id' => $post->restaurant_id]) }}"><button type="button" class="btn btn-secondary">Back</button></a>
        <button type="submit" class="btn btn-primary">Submit</button>
    </form>

    </div>
    </div>
</div>
@endsection

@section('scripts')
    @include('share.flatpickr.scripts')
    <script>
        function buttonCheck() {
            document.getElementById('js-dateForm').style.display = 'block';
        }
        function buttonUnCheck() {
            document.getElementById('js-dateForm').style.display = 'none';
        }
    </script>
@endsection

resources/views/posts/index.blade.php
@extends('layouts.app')
<style>
#post-want,
#post-done {
    display: none;
}
.border {
    width: 430px;
    border-radius: 4px;
    margin: 12px;
}
.done-title {
    padding: 12px;
    background: #6cb2eb;
}
.want-title {
    padding: 12px;
    background: #ffc107;
}

.post-body {
    padding: 12px;
    list-style: none;
}
</style>

@section('content')
    <div class="container">

    <div class="d-flex justify-content-between">
        <h1>My Restaurant's list</h1>
        <a href="{{ route('posts.create') }}">
            <button type="button" class="btn btn-outline-danger btn-lg">お店を登録する</button>
        </a>
    </div>

    <div class="d-flex justify-content-start">
        <button type="button" id="js_list-done" class="btn btn-info mx-2">行った</button>
        <button type="button" id="js_list-want" class="btn btn-warning mx-2">行きたい</button>
    </div>

    <div class="d-flex flex-wrap justify-content-start mt-5">
        @foreach($data as $datum)
        @php
            $post = Auth::user()->posts->where('restaurant_id', $datum['rest'][0]['id'])->first();
            $comment = Auth::user()->comments->where('restaurant_id', $datum['rest'][0]['id'])->first();
        @endphp

        @if($post->status == true)
        <div class="border border-primary">
            <div class="post-title done-title">
                <a href="{{ route('posts.show', ['id' => $datum['rest'][0]['id']]) }}" class="text-light">{{ $datum['rest'][0]['name'] }}</a>
            </div>
        @else
        <div class="border border-warning">
            <div class="post-title want-title">
                <a href="{{ route('posts.show', ['id' => $datum['rest'][0]['id']]) }}" class="text-muted">{{ $datum['rest'][0]['name'] }}</a>
            </div>
        @endif
            <ul class="post-body">
                <li>エリア：{{ $datum['rest'][0]['code']['areaname_s'] }}</li>
                @if($post->status == true)
                <li>行った日：{{ $post->formatted_date }}</li>
                @endif
            </ul>
        </div>
        @endforeach
    </div>

    @if(Auth::check())
    <script>
        document.getElementById('logout').addEventListener('click', function(event) {
            event.preventDefault();
            document.getElementById('logout-form').submit();
        });
    </script>
    @endif
@endsection

resources/views/posts/show.blade.php
@extends('layouts.app')
<style>
    li {
        list-style: none;
    }
    #googleMap {
    width: 100%;
    height: 400px;
    }
</style>
@section('content')

<div class="row">
    <div class="col-md-8 offset-md-2">
        <div class="card">
            <div class="card-header">
                <ul class="d-flex m-0 p-0">
                    <li class="flex-grow-1">{{ $datum['rest'][0]['name'] }}</li>
                    <li>
                        <a href="{{ route('posts.edit', ['id' => $post->restaurant_id]) }}">
                            <button type="button" class="btn btn-outline-secondary btn-sm mr-3">Edit</button>
                        </a>
                    </li>
                    <li>
                        <form action="{{ route('posts.destroy', ['id' => $post->restaurant_id]) }}" method="post" id="js_delete">
                            {{ csrf_field() }}
                            {{ method_field('delete') }}
                            <input type="submit" value="Delete" class="btn btn-danger btn-sm" onClick="deletePost(); return false;">
                        </form>
                    </li>
                </ul>
            </div>

            <div class="card-body">
                <h5 class="card-title"></h5>
                <ul class="card-text pl-0">
                    <li>エリア：{{ $datum['rest'][0]['code']['areaname_s'] }}</li>
                    <li>ステータス：{{ $post->status_label }}</li>
                    @if($post->status == 1)
                        <li>行った日：{{ $post->formatted_date }}</li>
                    @endif
                    <li>コメント：
                        @if(isset($comment))
                            {{ $comment->content }}
                        @endif
                    </li>
                    <li class="mb-3">住所：{{ $datum['rest'][0]['address'] }}</li>
                    <li><div id="googleMap"></div></li>
                    <li class="mt-3">
                        <img src="{{ $datum['rest'][0]['image_url']['shop_image1'] }}">
                    </li>
                </ul>
            </div>
        </div>
    </div>
    <div class="col-md-6 offset-md-3 mt-2">
        <a href="{{ route('posts.index') }}">back</a>
    </div>
</div>

@endsection

@section('scripts')
<script>
let lat = <?php echo $datum['rest'][0]['latitude']; ?>;
let lng = <?php echo $datum['rest'][0]['longitude']; ?>;

function initMap() {
    map = new google.maps.Map(document.getElementById('googleMap'), {
        center: { // 地図の中心を指定
            lat: lat, // 緯度
            lng: lng // 経度
        },
        zoom: 19 // 地図のズームを指定
    });

    latlng = new google.maps.LatLng(lat, lng);

    marker = new google.maps.Marker({
        position: latlng,
        map: map
    });
}
</script>
<script src="https://maps.googleapis.com/maps/api/js?key=AIzaSyAoYJq-xnKxQ-fLJf-2X0G9sZYEih7bbkk&callback=initMap" async defer></script>

<script>
function deletePost(e) {
    if(confirm('本当に削除しますか？')) {
        document.getElementById('js_delete').submit();
    }
}
</script>

resources/views/share/flatpickr/scripts.blade.php
<!-- flatpickrスクリプト -->
<script src="https://npmcdn.com/flatpickr/dist/flatpickr.min.js"></script>
<!-- 日本語化のための追加スクリプト -->
<script src="https://npmcdn.com/flatpickr/dist/l10n/ja.js"></script>
<script>
    flatpickr(document.getElementById('date'), {
        locale: 'ja',
        dateFormat: "Y/m/d",
        minDate: 2019/1/1,
        allowInput: true
    });
</script>

resources/views/share/flatpickr/styles.blade.php
<!-- デフォルトのスタイルシート -->
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/flatpickr/dist/flatpickr.min.css">
<!-- ブルーテーマの追加スタイルシート -->
<link rel="stylesheet" href="https://npmcdn.com/flatpickr/dist/themes/material_blue.css">